Index: TWiki/Client.pm
===================================================================
--- TWiki/Client.pm	(revision 13172)
+++ TWiki/Client.pm	(working copy)
@@ -94,7 +94,7 @@
 
 =pod
 
----++ StaticMethod makeLoginManager( $twiki ) -> $TWiki::Client
+---++ StaticMethod makeLoginManager() -> $TWiki::Client
 
 Factory method, used to generate a new TWiki::Client object
 for the given session.
@@ -102,11 +102,9 @@
 =cut
 
 sub makeLoginManager {
-    my $twiki = shift;
-    ASSERT($twiki->isa( 'TWiki')) if DEBUG;
 
     if( $TWiki::cfg{UseClientSessions} &&
-          !$twiki->inContext( 'command_line' )) {
+          !$TWiki::SESSION->inContext( 'command_line' )) {
 
         my $use = 'use CGI::Session';
         if( $TWiki::cfg{Sessions}{UseIPMatching} ) {
@@ -126,11 +124,11 @@
     my $mgr;
     if( $TWiki::cfg{LoginManager} eq 'none' ) {
         # No login manager; just use default behaviours
-        $mgr = new TWiki::Client( $twiki );
+        $mgr = new TWiki::Client();
     } else {
         eval 'use '. $TWiki::cfg{LoginManager};
         throw Error::Simple( $@ ) if $@;
-        $mgr = $TWiki::cfg{LoginManager}->new( $twiki );
+        $mgr = $TWiki::cfg{LoginManager}->new( $TWiki::SESSION );
     }
     return $mgr;
 }
@@ -138,11 +136,10 @@
 # protected: Construct new client object.
 
 sub new {
-    my ( $class, $twiki ) = @_;
+    my ( $class ) = @_;
     my $this = bless( {}, $class );
-    ASSERT($twiki->isa( 'TWiki')) if DEBUG;
-    $this->{twiki} = $twiki;
-    $twiki->leaveContext( 'can_login' );
+
+    $TWiki::SESSION->leaveContext( 'can_login' );
     $this->{_cookies} = [];
     map{ $this->{_authScripts}{$_} = 1; }
       split( /[\s,]+/, $TWiki::cfg{AuthScripts} );
@@ -216,7 +213,6 @@
 
 sub loadSession {
     my ($this, $defaultUser) = @_;
-    my $twiki = $this->{twiki};
 
     # Try and get the user from the webserver
     my $authUser = $this->getUser( $this ) || $defaultUser;
@@ -226,9 +222,9 @@
         return $authUser;
     }
 
-    return $authUser if $twiki->inContext( 'command_line' );
+    return $authUser if $TWiki::SESSION->inContext( 'command_line' );
 
-    my $query = $twiki->{cgiQuery};
+    my $query = $TWiki::SESSION->{cgiQuery};
 
     $this->{_haveCookie} = $query->raw_cookie();
 
@@ -306,8 +302,8 @@
 
     $this->userLoggedIn( $authUser );
 
-    $twiki->{SESSION_TAGS}{SESSIONID} = $this->{_cgisession}->id();
-    $twiki->{SESSION_TAGS}{SESSIONVAR} = $CGI::Session::NAME;
+    $TWiki::SESSION->{SESSION_TAGS}{SESSIONID} = $this->{_cgisession}->id();
+    $TWiki::SESSION->{SESSION_TAGS}{SESSIONVAR} = $CGI::Session::NAME;
 
     return $authUser;
 }
@@ -326,20 +322,19 @@
     return unless( $TWiki::cfg{UseClientSessions} );
 
     my $this = shift;
-    my $twiki = $this->{twiki};
 
-    return undef if $twiki->inContext( 'command_line' );
+    return undef if $TWiki::SESSION->inContext( 'command_line' );
 
-    unless( $twiki->inContext( 'authenticated' ) ||
+    unless( $TWiki::SESSION->inContext( 'authenticated' ) ||
               $TWiki::cfg{LoginManager} eq 'none' ) {
         my $script = $ENV{'SCRIPT_NAME'} || $ENV{'SCRIPT_FILENAME'};
         $script =~ s@^.*/([^./]+)@$1@g if $script;
 
         if( defined $script && $this->{_authScripts}{$script} ) {
-            my $topic = $this->{twiki}->{topicName};
-            my $web = $this->{twiki}->{webName};
+            my $topic = $TWiki::SESSION->{topicName};
+            my $web = $TWiki::SESSION->{webName};
             throw TWiki::AccessControlException(
-                $script, $this->{twiki}->{user}, $web, $topic,
+                $script, $TWiki::SESSION->{user}, $web, $topic,
                 'authentication required' );
         }
     }
@@ -420,15 +415,14 @@
 sub userLoggedIn {
     my( $this, $authUser, $wikiName ) = @_;
 
-    my $twiki = $this->{twiki};
-    return undef if $twiki->inContext( 'command_line' );
+    return undef if $TWiki::SESSION->inContext( 'command_line' );
 
     if( $TWiki::cfg{UseClientSessions} ) {
         # create new session if necessary
         unless( $this->{_cgisession} ) {
             $this->{_cgisession} =
               CGI::Session->new(
-                  undef, $twiki->{cgiQuery},
+                  undef, $TWiki::SESSION->{cgiQuery},
                   { Directory => $TWiki::cfg{TempfileDir} } );
             die CGI::Session->errstr() unless $this->{_cgisession};
         }
@@ -437,13 +431,13 @@
         _trace($this, "Session is authenticated");
         $this->{_cgisession}->param( 'AUTHUSER', $authUser )
           if( $TWiki::cfg{UseClientSessions} );
-        $twiki->enterContext( 'authenticated' );
+        $TWiki::SESSION->enterContext( 'authenticated' );
     } else {
         _trace($this, "Session is NOT authenticated");
         # if we are not authenticated, expire any existing session
         $this->{_cgisession}->clear( [ 'AUTHUSER' ] )
           if( $TWiki::cfg{UseClientSessions} );
-        $twiki->leaveContext( 'authenticated' );
+        $TWiki::SESSION->leaveContext( 'authenticated' );
     }
     if( $TWiki::cfg{UseClientSessions} ) {
         # flush the session, to try to fix Item1820 and Item2234
@@ -459,7 +453,7 @@
 
     my $s = $this->{_MYSCRIPTURL};
     unless( $s ) {
-        $s = quotemeta($this->{twiki}->getScriptUrl( 1, $M1, $M2, $M3 ));
+        $s = quotemeta($TWiki::SESSION->getScriptUrl( 1, $M1, $M2, $M3 ));
         $s =~ s@\\$M1@[^/]*?@go;
         $s =~ s@\\$M2@[^/]*?@go;
         $s =~ s@\\$M3@[^#\?/]*@go;
@@ -545,7 +539,7 @@
     return unless( $TWiki::cfg{UseClientSessions} );
 
     my $this = shift;
-    return undef if $this->{twiki}->inContext( 'command_line' );
+    return undef if $TWiki::SESSION->inContext( 'command_line' );
 
     # If cookies are not turned on and transparent CGI session IDs are,
     # grab every URL that is an internal link and pass a CGI variable
@@ -609,7 +603,7 @@
     return unless( $TWiki::cfg{UseClientSessions} );
 
     my( $this, $c ) = @_;
-    return undef if $this->{twiki}->inContext( 'command_line' );
+    return undef if $TWiki::SESSION->inContext( 'command_line' );
     ASSERT($c->isa('CGI::Cookie')) if DEBUG;
 
     push( @{$this->{_cookies}}, $c );
@@ -630,7 +624,7 @@
     return unless $this->{_cgisession};
     return if $TWiki::cfg{Sessions}{MapIP2SID};
 
-    my $query = $this->{twiki}->{cgiQuery};
+    my $query = $TWiki::SESSION->{cgiQuery};
     $this->_pushCookie();
     $hopts->{cookie} = $this->{_cookies};
 }
@@ -805,15 +799,12 @@
 
 sub _LOGIN {
     #my( $twiki, $params, $topic, $web ) = @_;
-    my $twiki = shift;
-    my $this = $twiki->{loginManager};
-    ASSERT($this->isa('TWiki::Client')) if DEBUG;
 
-    return '' if $twiki->inContext( 'authenticated' );
+    return '' if $TWiki::SESSION->inContext( 'authenticated' );
 
-    my $url = $this->loginUrl();
+    my $url = $TWiki::LOGIN->loginUrl();
     if( $url ) {
-        my $text = $twiki->{templates}->expandTemplate('LOG_IN');
+        my $text = $TWiki::TEMPLATES->expandTemplate('LOG_IN');
         return CGI::a( { href=>$url }, $text );
     }
     return '';
@@ -821,26 +812,21 @@
 
 sub _LOGOUTURL {
     my( $twiki, $params, $topic, $web ) = @_;
-    my $this = $twiki->{loginManager};
-    ASSERT($this->isa('TWiki::Client')) if DEBUG;
-
-    return $twiki->getScriptUrl(
+    return $TWiki::SESSION->getScriptUrl(
         0, 'view',
-        $twiki->{SESSION_TAGS}{BASEWEB},
-        $twiki->{SESSION_TAGS}{BASETOPIC},
+        $TWiki::SESSION->{SESSION_TAGS}{BASEWEB},
+        $TWiki::SESSION->{SESSION_TAGS}{BASETOPIC},
         'logout' => 1 );
 }
 
 sub _LOGOUT {
     my( $twiki, $params, $topic, $web ) = @_;
-    my $this = $twiki->{loginManager};
-    ASSERT($this->isa('TWiki::Client')) if DEBUG;
 
-    return '' unless $twiki->inContext( 'authenticated' );
+    return '' unless $TWiki::SESSION->inContext( 'authenticated' );
 
     my $url = _LOGOUTURL( @_ );
     if( $url ) {
-        my $text = $twiki->{templates}->expandTemplate('LOG_OUT');
+        my $text = $TWiki::TEMPLATES->expandTemplate('LOG_OUT');
         return CGI::a( {href=>$url }, $text );
     }
     return '';
@@ -848,10 +834,8 @@
 
 sub _AUTHENTICATED {
     my( $twiki, $params ) = @_;
-    my $this = $twiki->{loginManager};
-    ASSERT($this->isa('TWiki::Client')) if DEBUG;
 
-    if( $twiki->inContext( 'authenticated' )) {
+    if( $TWiki::SESSION->inContext( 'authenticated' )) {
         return $params->{then} || 1;
     } else {
         return $params->{else} || 0;
@@ -860,9 +844,8 @@
 
 sub _CANLOGIN {
     my( $twiki, $params ) = @_;
-    my $this = $twiki->{loginManager};
-    ASSERT($this->isa('TWiki::Client')) if DEBUG;
-    if( $twiki->inContext( 'can_login' )) {
+
+    if( $TWiki::SESSION->inContext( 'can_login' )) {
         return $params->{then} || 1;
     } else {
         return $params->{else} || 0;
@@ -871,26 +854,23 @@
 
 sub _SESSION_VARIABLE {
     my( $twiki, $params ) = @_;
-    my $this = $twiki->{loginManager};
-    ASSERT($this->isa('TWiki::Client')) if DEBUG;
+
     my $name = $params->{_DEFAULT};
 
     if( defined( $params->{set} ) ) {
-        $this->setSessionValue( $name, $params->{set} );
+        $TWiki::LOGIN->setSessionValue( $name, $params->{set} );
         return '';
     } elsif( defined( $params->{clear} )) {
-        $this->clearSessionValue( $name );
+        $TWiki::LOGIN->clearSessionValue( $name );
         return '';
     } else {
-        return $this->getSessionValue( $name ) || '';
+        return $TWiki::LOGIN->getSessionValue( $name ) || '';
     }
 }
 
 sub _LOGINURL {
     my( $twiki, $params ) = @_;
-    my $this = $twiki->{loginManager};
-    ASSERT($this->isa('TWiki::Client')) if DEBUG;
-    return $this->loginUrl();
+    return $TWiki::LOGIN->loginUrl();
 }
 
 sub _dispLogon {
@@ -898,9 +878,8 @@
 
     return '' unless $this->{_cgisession};
 
-    my $twiki = $this->{twiki};
-    my $topic = $twiki->{topicName};
-    my $web = $twiki->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $web = $TWiki::SESSION->{webName};
     my $sessionId = $this->{_cgisession}->id();
 
     my $urlToUse = $this->loginUrl();
@@ -909,15 +888,14 @@
         $urlToUse = $this->_rewriteURL( $urlToUse );
     }
 
-    my $text = $twiki->{templates}->expandTemplate('LOG_IN');
+    my $text = $TWiki::TEMPLATES->expandTemplate('LOG_IN');
     return CGI::a({ class => 'twikiAlert', href => $urlToUse }, $text );
 }
 
 sub _skinSelect {
     my $this = shift;
-    my $twiki = $this->{twiki};
-    my $skins = $twiki->{prefs}->getPreferencesValue('SKINS');
-    my $skin = $twiki->getSkin();
+    my $skins = $TWiki::PREFS->getPreferencesValue('SKINS');
+    my $skin = $TWiki::SESSION->getSkin();
     my @skins = split( /,/, $skins );
     unshift( @skins, 'default' );
     my $options = '';
Index: TWiki/Prefs.pm
===================================================================
--- TWiki/Prefs.pm	(revision 13172)
+++ TWiki/Prefs.pm	(working copy)
@@ -47,7 +47,7 @@
 
 =pod
 
----++ ClassMethod new( $session [, $cache] )
+---++ ClassMethod new( [$cache] )
 
 Creates a new Prefs object. If $cache is defined, it will be
 pushed onto the stack.
@@ -55,15 +55,14 @@
 =cut
 
 sub new {
-    my( $class, $session, $cache ) = @_;
+    my( $class, $cache ) = @_;
     my $this = bless( {}, $class );
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
-    $this->{session} = $session;
+
     push( @{$this->{PREFS}}, $cache ) if defined( $cache );
     # $this->{TOPICS} - hash of TWiki::Prefs objects, for solitary topics
     # $this->{WEBS} - hash of TWiki::Prefs objects, for solitary webs
     # remember what "Local" means
-    $this->{LOCAL} = $session->{webName}.'.'.$this->{session}->{topicName};
+    $this->{LOCAL} = $TWiki::SESSION->{webName}.'.'.$TWiki::SESSION->{topicName};
 
     return $this;
 }
@@ -166,7 +165,7 @@
 
     # Then local site prefs
     if( $TWiki::cfg{LocalSitePreferences} ) {
-        my( $lweb, $ltopic ) = $this->{session}->normalizeWebTopicName(
+        my( $lweb, $ltopic ) = $TWiki::SESSION->normalizeWebTopicName(
             undef, $TWiki::cfg{LocalSitePreferences} );
         $this->pushPreferences( $lweb, $ltopic, 'SITE' );
     }
@@ -336,7 +335,7 @@
     my $wtn = $web.'.'.$TWiki::cfg{WebPrefsTopicName};
 
     unless( $this->{WEBS}{$wtn} ) {
-        my $blank = new TWiki::Prefs( $this->{session} );
+        my $blank = new TWiki::Prefs();
         $blank->pushWebPreferences( $web );
         $this->{WEBS}{$wtn} = $blank;
     }
Index: TWiki/Render.pm
===================================================================
--- TWiki/Render.pm	(revision 13172)
+++ TWiki/Render.pm	(working copy)
@@ -67,7 +67,7 @@
 
 =pod
 
----++ ClassMethod new ($session)
+---++ ClassMethod new ()
 
 Creates a new renderer with initial state from preference values
 (NEWTOPICLINKSYMBOL LINKTOOLTIPINFO)
@@ -75,23 +75,20 @@
 =cut
 
 sub new {
-    my ( $class, $session ) = @_;
+    my ( $class ) = @_;
     my $this = bless( {}, $class );
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
 
-    $this->{session} = $session;
-
     $this->{NEWLINKSYMBOL} =
-      $session->{prefs}->getPreferencesValue('NEWTOPICLINKSYMBOL')
+      $TWiki::PREFS->getPreferencesValue('NEWTOPICLINKSYMBOL')
         || CGI::sup('?');
     $this->{NEWLINKFORMAT} =
-      $session->{prefs}->getPreferencesValue('NEWLINKFORMAT')
+      $TWiki::PREFS->getPreferencesValue('NEWLINKFORMAT')
         || '<span class="twikiNewLink">$text<a href="%SCRIPTURLPATH{"edit"}%/$web/$topic?topicparent=%WEB%.%TOPIC%" '.
 	   'rel="nofollow" title="%MAKETEXT{"Create this topic"}%">'.
            '$linksymbol</a></span>';
     # tooltip init
     $this->{LINKTOOLTIPINFO} =
-      $session->{prefs}->getPreferencesValue('LINKTOOLTIPINFO')
+      $TWiki::PREFS->getPreferencesValue('LINKTOOLTIPINFO')
         || '';
     $this->{LINKTOOLTIPINFO} = '$username - $date - r$rev: $summary'
       if( TWiki::isTrue( $this->{LINKTOOLTIPINFO} ));
@@ -126,7 +123,7 @@
     my $text = '';
     my $parentMeta = $meta->get( 'TOPICPARENT' );
     my $parent;
-    my $store = $this->{session}->{store};
+    my $store = $TWiki::STORE;
 
     $parent = $parentMeta->{name} if $parentMeta;
 
@@ -134,7 +131,7 @@
 
     while( $parent ) {
         ( $pWeb, $pTopic ) =
-          $this->{session}->normalizeWebTopicName( $pWeb, $parent );
+          $TWiki::SESSION->normalizeWebTopicName( $pWeb, $parent );
         $parent = $pWeb.'.'.$pTopic;
         last if( $noWebHome &&
                  ( $pTopic eq $TWiki::cfg{HomeTopicName} ) ||
@@ -173,11 +170,11 @@
 
     if( $moved ) {
         my( $fromWeb, $fromTopic ) =
-          $this->{session}->normalizeWebTopicName( $web, $moved->{from} );
+          $TWiki::SESSION->normalizeWebTopicName( $web, $moved->{from} );
         my( $toWeb, $toTopic ) =
-          $this->{session}->normalizeWebTopicName( $web, $moved->{to} );
+          $TWiki::SESSION->normalizeWebTopicName( $web, $moved->{to} );
         my $by = $moved->{by};
-        my $u = $this->{session}->{users}->findUser( $by );
+        my $u = $TWiki::USERS->findUser( $by );
         $by = $u->webDotWikiName() if $u;
         my $date = TWiki::Time::formatTime( $moved->{date}, '', 'gmtime' );
 
@@ -185,10 +182,10 @@
         my $putBack = '';
         if( $web eq $toWeb && $topic eq $toTopic ) {
             $putBack  = ' - '.
-              CGI::a( { title=>($this->{session}->{i18n}->maketext(
+              CGI::a( { title=>($TWiki::I18N->maketext(
                                   'Click to move topic back to previous location, with option to change references.')
                                ),
-                        href => $this->{session}->getScriptUrl
+                        href => $TWiki::SESSION->getScriptUrl
                         ( 0, 'rename', $web, $topic,
                          newweb => $fromWeb,
                          newtopic => $fromTopic,
@@ -196,10 +193,10 @@
                          nonwikiword => 'checked' ),
                         rel => 'nofollow'
                       },
-                      $this->{session}->{i18n}->maketext('put it back') );
+                      $TWiki::I18N->maketext('put it back') );
         }
         $text = CGI::i(
-          $this->{session}->{i18n}->maketext("[_1] moved from [_2] on [_3] by [_4]",
+          $TWiki::I18N->maketext("[_1] moved from [_2] on [_3] by [_4]",
                                              "<nop>$toWeb.<nop>$toTopic",
                                              "<nop>$fromWeb.<nop>$fromTopic",
                                              $date,
@@ -423,12 +420,12 @@
     my( $this, $theWeb, $theTopic ) = @_;
     return '' unless( $this->{LINKTOOLTIPINFO} );
     return '' if( $this->{LINKTOOLTIPINFO} =~ /^off$/i );
-    return '' unless( $this->{session}->inContext( 'view' ));
+    return '' unless( $TWiki::SESSION->inContext( 'view' ));
 
     # FIXME: This is slow, it can be improved by caching topic rev info and summary
-    my $store = $this->{session}->{store};
+    my $store = $TWiki::STORE;
     # SMELL: we ought not to have to fake this. Topic object model, please!!
-    my $meta = new TWiki::Meta( $this->{session}, $theWeb, $theTopic );
+    my $meta = new TWiki::Meta( $theWeb, $theTopic );
     my( $date, $user, $rev ) = $meta->getRevisionInfo();
     my $text = $this->{LINKTOOLTIPINFO};
     $text =~ s/\$web/<nop>$theWeb/g;
@@ -485,7 +482,7 @@
 
     #WebHome links to tother webs render as the WebName
     if (($theLinkText eq $TWiki::cfg{HomeTopicName}) && 
-        ($theWeb ne $this->{session}->{webName})) {
+        ($theWeb ne $TWiki::SESSION->{webName})) {
             $theLinkText = $theWeb;
     }
 
@@ -508,7 +505,7 @@
 # TODO: this should be overridable by plugins.
 sub _renderWikiWord {
     my ($this, $theWeb, $theTopic, $theLinkText, $theAnchor, $doLinkToMissingPages, $doKeepWeb) = @_;
-    my $store = $this->{session}->{store};
+    my $store = $TWiki::STORE;
     my $topicExists = $store->topicExists( $theWeb, $theTopic );
 
     my $singular = '';
@@ -544,15 +541,15 @@
     my ($this, $web, $topic, $text, $anchor) = @_;
 
     my $currentWebHome = '';
-    $currentWebHome = 'twikiCurrentWebHomeLink ' if (($web eq $this->{session}->{webName}) &&
+    $currentWebHome = 'twikiCurrentWebHomeLink ' if (($web eq $TWiki::SESSION->{webName}) &&
                                       ($topic eq $TWiki::cfg{HomeTopicName} ));
 
     my $currentTopic = '';
-    $currentTopic = 'twikiCurrentTopicLink ' if (($web eq $this->{session}->{webName}) &&
-                                       ($topic eq $this->{session}->{topicName}));
+    $currentTopic = 'twikiCurrentTopicLink ' if (($web eq $TWiki::SESSION->{webName}) &&
+                                       ($topic eq $TWiki::SESSION->{topicName}));
 
     my @attrs;
-    my $href = $this->{session}->getScriptUrl( 0, 'view', $web, $topic );
+    my $href = $TWiki::SESSION->getScriptUrl( 0, 'view', $web, $topic );
     if( $anchor ) {
         $anchor = $this->makeAnchorName( $anchor );
         push( @attrs, class => $currentTopic.$currentWebHome.'twikiAnchorLink', href => $href.'#'.$anchor );
@@ -578,8 +575,8 @@
     $ans =~ s/\$topic/$topic/g;
     $ans =~ s/\$text/$text/g;
     $ans =~ s/\$linksymbol/$this->{NEWLINKSYMBOL}/g;
-    $ans = $this->{session}->handleCommonTags(
-        $ans, $this->{session}{webName}, $this->{session}{topicName});
+    $ans = $TWiki::SESSION->handleCommonTags(
+        $ans, $TWiki::SESSION->{webName}, $TWiki::SESSION->{topicName});
     return $ans;
 }
 
@@ -613,7 +610,7 @@
 
         # 'Web.TopicName' or 'Web.ABBREV' link:
         if ( $topic eq $TWiki::cfg{HomeTopicName} &&
-             $web ne $this->{session}->{webName} ) {
+             $web ne $TWiki::SESSION->{webName} ) {
             $text = $web;
         } else {
             $text = $topic;
@@ -621,11 +618,11 @@
     }
 
     # Allow spacing out, etc
-    $text = $this->{session}->{plugins}->renderWikiWordHandler( $text ) || $text;
+    $text = $TWiki::PLUGINS->renderWikiWordHandler( $text ) || $text;
 
     # =$doKeepWeb= boolean: true to keep web prefix (for non existing Web.TOPIC)
     # (Necessary to leave "web part" of ABR.ABR.ABR intact if topic not found)
-    $keepWeb = ( $topic =~ /^$TWiki::regex{abbrevRegex}$/o && $web ne $this->{session}->{webName} );
+    $keepWeb = ( $topic =~ /^$TWiki::regex{abbrevRegex}$/o && $web ne $TWiki::SESSION->{webName} );
 
     # false means suppress link for non-existing pages
     $linkIfAbsent = ( $topic !~ /^$TWiki::regex{abbrevRegex}$/o );
@@ -694,7 +691,7 @@
     $topic = $link if( $link );
 
     # Topic defaults to the current topic
-    ($web, $topic) = $this->{session}->normalizeWebTopicName( $web, $topic );
+    ($web, $topic) = $TWiki::SESSION->normalizeWebTopicName( $web, $topic );
 
     return $this->internalLink( $web, $topic, $text, $anchor, 1, undef );
 }
@@ -790,11 +787,11 @@
     }
 
     my $meta = $this->{ffCache}{$formWeb.'.'.$formTopic};
-    my $store = $this->{session}->{store};
+    my $store = $TWiki::STORE;
     unless ( $meta ) {
         my $dummyText;
         ( $meta, $dummyText ) =
-          $store->readTopic( $this->{session}->{user}, $formWeb, $formTopic, $rev );
+          $store->readTopic( $TWiki::SESSION->{user}, $formWeb, $formTopic, $rev );
         $this->{ffCache}{$formWeb.'.'.$formTopic} = $meta;
     }
 
@@ -844,12 +841,9 @@
 
     return '' unless $text;  # nothing to do
 
-    $theTopic ||= $this->{session}->{topicName};
-    $theWeb ||= $this->{session}->{webName};
-    my $session = $this->{session};
-    my $plugins = $session->{plugins};
-    my $prefs = $session->{prefs};
-    
+    $theTopic ||= $TWiki::SESSION->{topicName};
+    $theWeb ||= $TWiki::SESSION->{webName};
+
     @{$this->{LIST}} = ();
 
     # Initial cleanup
@@ -884,23 +878,23 @@
     # DEPRECATED startRenderingHandler before PRE removed
     # SMELL: could parse more efficiently if this wasn't
     # here.
-    $plugins->startRenderingHandler( $text, $theWeb, $theTopic );
+    $TWiki::PLUGINS->startRenderingHandler( $text, $theWeb, $theTopic );
 
     $text = $this->takeOutBlocks( $text, 'pre', $removed );
 
     # Join lines ending in '\' (don't need \r?, it was removed already)
     $text =~ s/\\\n//gs;
 
-    $plugins->preRenderingHandler( $text, $removed );
+    $TWiki::PLUGINS->preRenderingHandler( $text, $removed );
 
-    if( $plugins->haveHandlerFor( 'insidePREHandler' )) {
+    if( $TWiki::PLUGINS->haveHandlerFor( 'insidePREHandler' )) {
         foreach my $region ( sort keys %$removed ) {
             next unless ( $region =~ /^pre\d+$/i );
             my @lines = split( /\r?\n/, $removed->{$region}{text} );
             my $rt = '';
             while ( scalar( @lines )) {
                 my $line = shift( @lines );
-                $plugins->insidePREHandler( $line );
+                $TWiki::PLUGINS->insidePREHandler( $line );
                 if ( $line =~ /\n/ ) {
                     unshift( @lines, split( /\r?\n/, $line ));
                     next;
@@ -911,7 +905,7 @@
         }
     }
 
-    if( $plugins->haveHandlerFor( 'outsidePREHandler' )) {
+    if( $TWiki::PLUGINS->haveHandlerFor( 'outsidePREHandler' )) {
         # DEPRECATED - this is the one call preventing
         # effective optimisation of the TWiki ML processing loop,
         # as it exposes the concept of a 'line loop' to plugins,
@@ -922,7 +916,7 @@
         my $rt = '';
         while ( scalar( @lines ) ) {
             my $line = shift( @lines );
-            $plugins->outsidePREHandler( $line );
+            $TWiki::PLUGINS->outsidePREHandler( $line );
             if ( $line =~ /\n/ ) {
                 unshift( @lines, split( /\r?\n/, $line ));
                 next;
@@ -1091,7 +1085,7 @@
     # i.e. [[$1][$3]]
     $text =~ s/\[\[([^\]\[\n]+)\](\[([^\]\n]+)\])?\]/$this->_handleSquareBracketedLink($theWeb,$theTopic,$1,$3)/ge;
     
-    unless( TWiki::isTrue( $prefs->getPreferencesValue('NOAUTOLINK')) ) {
+    unless( TWiki::isTrue( $TWiki::PREFS->getPreferencesValue('NOAUTOLINK')) ) {
         # Handle WikiWords
         $text = $this->takeOutBlocks( $text, 'noautolink', $removed );
         $text =~ s/$STARTWW(?:($TWiki::regex{webNameRegex})\.)?($TWiki::regex{wikiWordRegex}|$TWiki::regex{abbrevRegex})($TWiki::regex{anchorRegex})?/$this->_handleWikiWord($theWeb,$1,$2,$3)/geom;
@@ -1101,7 +1095,7 @@
     $this->putBackBlocks( \$text, $removed, 'pre' );
 
     # DEPRECATED plugins hook after PRE re-inserted
-    $plugins->endRenderingHandler( $text );
+    $TWiki::PLUGINS->endRenderingHandler( $text );
 
     # replace verbatim with pre in the final output
     $this->putBackBlocks( \$text, $removedVerbatim,
@@ -1115,9 +1109,9 @@
     $this->putBackProtected( \$text, $removedHead );
     $this->putBackProtected( \$text, $removedComments );
 
-    $this->{session}->{loginManager}->endRenderingHandler( $text );
+    $TWiki::LOGIN->endRenderingHandler( $text );
 
-    $plugins->postRenderingHandler( $text );
+    $TWiki::PLUGINS->postRenderingHandler( $text );
     return $text;
 }
 
@@ -1189,11 +1183,11 @@
 
     if( $opts =~ /expandvar/ ) {
         $text =~ s/(\%)(SEARCH){/$1<nop>$2/g; # prevent recursion
-        $text = $this->{session}->handleCommonTags( $text, $web, $topic );
+        $text = $TWiki::SESSION->handleCommonTags( $text, $web, $topic );
     } else {
         $text =~ s/%WEB%/$web/g;
         $text =~ s/%TOPIC%/$topic/g;
-        my $wtn = $this->{session}->{prefs}->getPreferencesValue(
+        my $wtn = $TWiki::PREFS->getPreferencesValue(
             'WIKITOOLNAME' ) || '';
         $text =~ s/%WIKITOOLNAME%/$wtn/g;
         if( $opts =~ /showvar/ ) {
@@ -1258,7 +1252,7 @@
     # characters. Only works for ISO-8859-1 sites, since the Unicode
     # encoding (&#nnn;) is identical for first 256 characters. 
     # I18N TODO: Convert to Unicode from any site character set.
-    if( $this->{session}->inContext( 'rss' ) &&
+    if( $TWiki::SESSION->inContext( 'rss' ) &&
           defined( $TWiki::cfg{Site}{CharSet} ) &&
             $TWiki::cfg{Site}{CharSet} =~ /^iso-?8859-?1$/i ) {
         $text =~ s/([\x7f-\xff])/"\&\#" . unpack( 'C', $1 ) .';'/ge;
@@ -1535,7 +1529,7 @@
 sub renderRevisionInfo {
     my( $this, $web, $topic, $meta, $rrev, $format ) = @_;
     ASSERT($this->isa( 'TWiki::Render')) if DEBUG;
-    my $store = $this->{session}->{store};
+    my $store = $TWiki::STORE;
 
     if( $rrev ) {
         $rrev = $store->cleanUpRevID( $rrev );
@@ -1599,7 +1593,7 @@
     ASSERT($this->isa( 'TWiki::Render')) if DEBUG;
     #ASSERT($user->isa( 'TWiki::User')) if DEBUG;
     my $summary = '';
-    my $store = $this->{session}->{store};
+    my $store = $TWiki::STORE;
 
     $orev = $nrev - 1 unless (defined($orev) || !defined($nrev));
 
@@ -1633,7 +1627,7 @@
                 if( $tml ) {
                     $block =~ s/^-(.*)$/CGI::del( $1 )/se;
                     $block =~ s/^\+(.*)$/CGI::ins( $1 )/se;
-                } elsif ( $this->{session}->inContext('rss')) {
+                } elsif ( $TWiki::SESSION->inContext('rss')) {
                     $block =~ s/^-/REMOVED: /;
                     $block =~ s/^\+/INSERTED: /;
                 }
@@ -1819,7 +1813,7 @@
     my( $this, $text, $meta, $oldWeb, $oldTopic, $newWeb, $newTopic ) = @_;
     ASSERT($this->isa( 'TWiki::Render')) if DEBUG;
 
-    my @topics = $this->{session}->{store}->getTopicNames( $oldWeb );
+    my @topics = $TWiki::STORE->getTopicNames( $oldWeb );
     my $options =
       {
        # exclude this topic from the list
@@ -1840,7 +1834,7 @@
                                  \&_replaceInternalRefs, $options );
 
     ## Ok, let's do it again, but look for links to topics in the new web and remove their full paths
-    @topics = $this->{session}->{store}->getTopicNames( $newWeb );
+    @topics = $TWiki::STORE->getTopicNames( $newWeb );
     $options =
       {
        # exclude this topic from the list
